--pathtest = string.match(test, "(.*/)")

require("dataqueue")
require("carts_common")

--print(package.path)
--print(package.cpath)
--
--local info = debug.getinfo(1, "S")
--local path = info.source
--path = string.sub(path, 2, -1)
--path = string.match(path, "^.*/")
--print(path)
--
--package.cpath = path.."?.so;"..package.cpath;
--print(package.cpath)
--require("dataqueue")
--startvalue = 15000001
--usercount  = 15000000
function get_uniform(s, e)
    return math.random(math.floor(s), math.floor(e))
end
sb_rand = sysbench.rand.default

function set_rand_uniform()
    -- 如果采用了随机种子，恢复成默认sysbench生成随机数的方式
    -- 只能在thread_init 和 cmd_prepare/cmd_warmup 中调用
    if (sysbench.opt.rand_seed > 0) then
        sb_rand_uniform = sysbench.rand.uniform
    else
        sb_rand_uniform = get_uniform
    end
end

usernum=300000000

function prepare_statements()
   -- We do not use prepared statements here, but oltp_common.sh expects this
   -- function to be defined
   --dataqueue.queueInit(0,20)
end



function sleep(n)
    os.execute("sleep "..tonumber(n))
end

--function thread_init(thread_id)
--
--end

function get_pkid(max_num)
    -- 用于根据线程号区分取值区间，不同线程之间的事务不会触发行锁
    -- 获取当前线程号
    local _start
    local _end
    _start =  max_num *  (sysbench.tid/sysbench.opt.threads)
    _end = max_num *  ((sysbench.tid + 1 )/sysbench.opt.threads)
    return get_uniform(_start, _end)
end


--function normal()
--    -- 对应日常操作，即"立即购买行为",insert后直接update，过一遍购物车后直接失效，不过队列
--    con:query("begin")
--    user_id=get_pkid(usernum)
--    cart_id=sb_rand_uniform(1,user_id)
--    table="member_cart_"..sb_rand_uniform(1,tables)
--    sql="INSERT ignore INTO " ..table.. " (`cart_id`,`sku_id`,`item_id`,`quantity`,`user_id`,`status`,`type`,`sub_type`,`gmt_create`,`gmt_modified`,`attribute`,`attribute_cc`,`sync_version`,`ex1`,`ex2`,`seller_id`,`ext_status`) VALUES("
--                ..cart_id..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..user_id..","..tostring(1)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10)..",".."now(),".."now(),".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 1000000000000)..",".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 100)..")"
--
--    con:query(sql)
--    con:query("commit")
--    return user_id,cart_id,table
--end



--user_id,table_id,repeat_id=insert()

--print(user_id)


function select_1(user_id,table,repeat_id)
--购物车总量查询
    local sql
    sql = "select  COUNT(1) from "..table.." where user_id="..user_id.." and status=1 and type in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
    --con:query("begin")
    --print(sql)
    con:query(sql)
    --con:query("commit")

end

function select_2(user_id,table,repeat_id)
--查看购物车列表
    local sql
    --con:query("begin")
    --user_id=sb_rand_uniform(15000000,30000000)
    --table_id=math.fmod(user_id, tables)
    --table = "member_cart_".."_".. table_id
    sql ="SELECT CART_ID, SKU_ID, ITEM_ID, QUANTITY, USER_ID, SELLER_ID, STATUS, EXT_STATUS, TYPE, SUB_TYPE, GMT_CREATE, GMT_MODIFIED, ATTRIBUTE, ATTRIBUTE_CC, EX2 FROM "..table.." WHERE USER_ID="..user_id.." AND STATUS=1 and type in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
    --print(sql)
    con:query(sql)
    --con:query("commit")

end

function select_3(user_id,table,repeat_id)
--通过购物车查看商品
    local sql
    --con:query("begin")
    sql ="SELECT CART_ID, SKU_ID, ITEM_ID, QUANTITY, USER_ID, SELLER_ID, STATUS, EXT_STATUS, TYPE, SUB_TYPE, GMT_CREATE, GMT_MODIFIED, ATTRIBUTE, ATTRIBUTE_CC, EX2 FROM "..table.." WHERE USER_ID="..user_id.." AND STATUS=1 and cart_id in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
    --print(sql)
    con:query(sql)
    --con:query("commit")

end

function select_4(user_id,table,repeat_id)
    local sql
    sql = "SELECT * FROM "..table.." where cart_id="..sb_rand_uniform(1,repeat_id)
    --print(sql)
    con:query(sql)
end

function select_5(user_id,table,repeat_id)
    local sql
	sql ="select * from "..table
   -- print(sql)
    con:query(sql)
end

function event()
    local user_id=get_pkid(usernum)
    local table_id=sb_rand_uniform(1,sysbench.opt.tables)
    local range_id = sb_rand_uniform(1,13)
    local repeat_id = sb_rand_uniform(range_id *10-10,range_id *10)
    local table = "member_cart_"..table_id
    op = sb_rand_uniform(1,5)
    if op == 1 then
    --con:query("begin")
        select_1(user_id,table,repeat_id)
    elseif op == 2 then
    --print(sql)
--        select_1(user_id,table,repeat_id)
        select_2(user_id,table,repeat_id)
	elseif op == 3 then
--        select_1(user_id,table,repeat_id)
--        select_2(user_id,table,repeat_id)
        select_3(user_id,table,repeat_id)
	elseif op == 4 then
    	select_4(user_id,table,repeat_id)
	else
    	select_5(user_id,table,repeat_id)
	end	

end

