function thread_init(thread_id)

  drv = sysbench.sql.driver()
  con = drv:connect()
  replica_con = {}

  if drv:name() == "mysql" then
    con:query("SET autocommit=0")
  end


    rs = con:query("select slave_host, slave_port from information_schema.INNODB_LOG_READER where role = 'replica' and status = 'active'")

    replica_count = rs.nrows
    for i = 1, replica_count do
      row = rs:fetch_row()
      local slave_host = tostring('11.163.185.31')
      local slave_port = tonumber(row[2])
      replica_con[i] = ffi.C.db_connection_create2(drv, slave_host, slave_port)

      if replica_con[i] == nil then
        print("Connection to replica failed")
        os.exit()
      end

      if drv:name() == "mysql" then
        replica_con[i]:query("SET autocommit=0")
      end

    end
end

function event()
  local port = con:query_row("select @@port")
  print(string.format("port: %s\n", port))
  port = replica_con[1]:query_row("select @@port")
  print(string.format("port: %s\n", port))
end

function sysbench.hooks.before_restart_event(err)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
-- --   print("my stat: ", val)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end


