#!/usr/bin/env sysbench
-- ----------------------------------------------------------------------
-- execute ddl related common files
-- ----------------------------------------------------------------------
sysbench.cmdline.options={
	tableName=
	{"do ddl for target table,which is the table Name",nil},
	tableSize=
	{"how many current table will be created",1},
	ddl=
	{"the ddl sql",nil}
}

function drop_table(drv, con, tablename,ddl)
	if ddl ~=  nil then
	    local tmp_drop=string.format("drop table if exists %s",tablename)
		print("[drop_ddl.lua] ddl for "..tablename)
		con:query(tmp_drop)
	end
end


function cmd_prepare()
	local drv = sysbench.sql.driver()
	local con = drv:connect()
	local tableName=sysbench.opt.tableName
	local ddl_sql=sysbench.opt.ddl
	local size=sysbench.opt.tableSize
	for i=1,size do
		local newName=tableName..i
		local newSQL=string.gsub(ddl_sql,tableName,newName)
		drop_table(drv, con, newName,newSQL)
	end
end


function event()
end

sysbench.cmdline.commands = {
	prepare = {cmd_prepare, sysbench.cmdline.PARALLEL_COMMAND}
}
