-- /root/sysbench/bin/sysbench --mysql-ignore-errors=2006,1213,3019,1412,1205,13259,3790,8008 --mysql_password=Passw0rd --report_interval=1 --mysql_db=tpch10g --mysql_host=100.81.231.222 --db_driver=mysql --mysql_user=myadmin --threads=10 --mysql_port=5200 --time=0 --events=0  --db-ps-mode=disable tpch_long_query.lua run
require("timed_event")

if sysbench.cmdline.command == nil then
    error("Command is required. Supported commands: run")
end

sysbench.cmdline.options={
    report_csv =
       {"Report output in csv (yes, no)", "no"},
    target_tps =
       {"Desiried transaction throughput (TPS)",-1}
}



function thread_init(thread_id)
   drv = sysbench.sql.driver()
   con = drv:connect()
end

function event()
    long_num =  sysbench.rand.uniform(1,22)
    local long_file  = "queries/tpch/tpch"..long_num..".sql"
    local stmt = stmt_from(long_file)
    con:query(stmt)

end


function file_exists(file)
   -- print ("check file exsits"..file)
  local f = io.open(file, "rb")
  if f then f:close() end
  return f ~= nil
end

function stmt_from(file)
    if not file_exists(file) then
        print ("file not exists")
        return {}
    end
    local stmt = ""
    local myfile = io.open(file,'r')
    for line in myfile:lines()  do
        if string.sub(line,1,2) =="--" then
            -- print ("annotation")
        else
            stmt = stmt.." "..line
        end
    end
    -- print (stmt)
    return stmt
end

function sysbench.hooks.report_intermediate(stat)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end



