--pathtest = string.match(test, "(.*/)")

require("dataqueue")
require("carts_common")

--print(package.path)
--print(package.cpath)
--
--local info = debug.getinfo(1, "S")
--local path = info.source
--path = string.sub(path, 2, -1)
--path = string.match(path, "^.*/")
--print(path)
--
--package.cpath = path.."?.so;"..package.cpath;
--print(package.cpath)
--require("dataqueue")
--startvalue = 15000001
--usercount  = 15000000

usernum=300000000

function prepare_statements()
   -- We do not use prepared statements here, but oltp_common.sh expects this
   -- function to be defined
   --dataqueue.queueInit(0,20)
end


function get_pkid(max_num)
    -- 用于根据线程号区分取值区间，不同线程之间的事务不会触发行锁
    -- 获取当前线程号
    local _start
    local _end
    _start =  max_num *  (sysbench.tid/sysbench.opt.threads)
    _end = max_num *  ((sysbench.tid + 1 )/sysbench.opt.threads)
    return sb_rand_uniform(_start, _end)
end


--function normal()
--	-- 对应日常操作，即"立即购买行为",insert后直接update，过一遍购物车后直接失效，不过队列
--	con:query("begin")
--	user_id=get_pkid(usernum)
--	cart_id=sb_rand_uniform(1,user_id)
--	table="member_cart_"..sb_rand_uniform(1,tables)
--	sql="INSERT ignore INTO " ..table.. " (`cart_id`,`sku_id`,`item_id`,`quantity`,`user_id`,`status`,`type`,`sub_type`,`gmt_create`,`gmt_modified`,`attribute`,`attribute_cc`,`sync_version`,`ex1`,`ex2`,`seller_id`,`ext_status`) VALUES("
--				..cart_id..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..user_id..","..tostring(1)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10)..",".."now(),".."now(),".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 1000000000000)..",".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 100)..")"
--
--	con:query(sql)
--	con:query("commit")
--	return user_id,cart_id,table
--end


function insert_push_dataqueue()
--初始化5个队列，insert数据先随机推到5个insert队列中,记录每次insert的值和其最大repeat_id
	local range_id
	local repeat_id
	local user_id
	local cart_id
	local table_id
	local queueid
	range_id = sb_rand(1, 13)
	repeat_id = sb_rand_uniform(range_id *10-10,range_id *10)
	user_id=get_pkid(usernum)
	table_id=sb_rand_uniform(1,sysbench.opt.tables)
	for  cart_id=1,repeat_id do
		queueid=sb_rand_uniform(1,5)
		if dataqueue.queueFull(queueid) == 0 then
			local i=user_id..","..cart_id..","..table_id..","..repeat_id..",1,"..repeat_id
			dataqueue.queueLockPush(queueid,i);
		end
	end
end

function pop_dataqueue(queueid)
	local userid_repeatid_table = dataqueue.queueLockPop(queueid)
	return userid_repeatid_table
end


function insert(user_id,table,cart_id)
		--do insert
	--	con:query("begin")
		local sql
		if drv:name() == "pgsql" then
			sql= "INSERT INTO " .. table .. " (cart_id,sku_id,item_id,quantity,user_id,status,type,sub_type,gmt_create,gmt_modified,attribute,attribute_cc,sync_version,ex1,ex2,seller_id,ext_status) VALUES("..cart_id..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..user_id..","..sb_rand_uniform(1,2)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10)..",".."now(),".."now(),".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 1000000000000)..",".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 100)..")"
		else
			sql= "INSERT ignore INTO " .. table .. " (`cart_id`,`sku_id`,`item_id`,`quantity`,`user_id`,`status`,`type`,`sub_type`,`gmt_create`,`gmt_modified`,`attribute`,`attribute_cc`,`sync_version`,`ex1`,`ex2`,`seller_id`,`ext_status`) VALUES("..cart_id..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..user_id..","..sb_rand_uniform(1,2)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10)..",".."now(),".."now(),".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 1000000000000)..",".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 100)..")"
		end
		con:query(sql)
	--	con:query("commit")
		--print(sql)
	--return user_id,table_id,repeat_id
end

--user_id,table_id,repeat_id=insert()

--print(user_id)

function update_1(user_id,table,cart_id)
--根据复合主键更新唯一记录,从10号队列取数据，做update
    local sql
	--con:query("begin")
	--table = "member_cart_".. table_id
	sql = "update ".. table .." SET status=".. tostring(sb_rand_uniform(0,1)).." ,gmt_modified='"..time.."' WHERE user_id="..user_id.." AND cart_id="..cart_id
	--print(sql)
	con:query(sql)
	--con:query("commit")

end

function update_2(user_id,table,repeat_id,min_cartid,max_cartid)
--根据复合主键同时更新多条记录，要求必须在给到user_id的时候知道有多少cart_id，否则可能出现无效in值,从队列中取
    --local table
    local sql
	sql = "update ".. table .." SET status="..tostring(sb_rand_uniform(0,1)).." ,gmt_modified='"..time.."' WHERE user_id="
			.. user_id.." AND cart_id in ("..random_in(min_cartid,max_cartid,sb_rand_uniform(1,repeat_id))..") and status="..tostring(sb_rand_uniform(0,1))
	--print(sql)

	--con:query("begin")
	con:query(sql)
	--con:query("commit")
end

function select_1(user_id,table,repeat_id)
--购物车总量查询
    local sql
	sql = "select  COUNT(1) from "..table.." where user_id="..user_id.." and status=1 and type in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
	--con:query("begin")
	--print(sql)
	con:query(sql)
	--con:query("commit")

end

function select_2(user_id,table,repeat_id)
--查看购物车列表
	local sql
	--con:query("begin")
	--user_id=sb_rand_uniform(15000000,30000000)
	--table_id=math.fmod(user_id, tables)
	--table = "member_cart_".."_".. table_id
	sql ="SELECT CART_ID, SKU_ID, ITEM_ID, QUANTITY, USER_ID, SELLER_ID, STATUS, EXT_STATUS, TYPE, SUB_TYPE, GMT_CREATE, GMT_MODIFIED, ATTRIBUTE, ATTRIBUTE_CC, EX2 FROM "..table.." WHERE USER_ID="..user_id.." AND STATUS=1 and type in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
	--print(sql)
	con:query(sql)
	--con:query("commit")

end

function select_3(user_id,table,repeat_id)
--通过购物车查看商品
	local sql
	--con:query("begin")
	sql ="SELECT CART_ID, SKU_ID, ITEM_ID, QUANTITY, USER_ID, SELLER_ID, STATUS, EXT_STATUS, TYPE, SUB_TYPE, GMT_CREATE, GMT_MODIFIED, ATTRIBUTE, ATTRIBUTE_CC, EX2 FROM "..table.." WHERE USER_ID="..user_id.." AND STATUS=1 and cart_id in ("..random_in(1,repeat_id,sb_rand_uniform(1,repeat_id))..")"
	--print(sql)
	con:query(sql)
	--con:query("commit")

end



function event()

	local  addcarts=sysbench.opt.addcarts
	local  queryCartsList=sysbench.opt.queryCartsList
	local  queryItemByCarts=sysbench.opt.queryItemByCarts
	local  updateItemQuantity=sysbench.opt.updateItemQuantity
	local  deleteByOrder=sysbench.opt.deleteByOrder
	local  deleteByUser=sysbench.opt.deleteByUser
    time = os.date("%Y-%m-%d %H:%M:%S", os.time())
	local total=addcarts+queryCartsList+queryItemByCarts+updateItemQuantity+deleteByOrder+deleteByUser

	local addcarts_range=addcarts
	local queryCartsList_range=addcarts_range+queryCartsList
	local queryItemByCarts_range=queryCartsList_range+queryItemByCarts
	local updateItemQuantity_range=queryItemByCarts_range+updateItemQuantity
	local deleteByOrder_range=updateItemQuantity_range+deleteByOrder
	local deleteByUser_range=deleteByOrder_range+deleteByUser

	local weight=sb_rand_uniform(1,total)

	local userid_repeatid_table,user_id,cart_id,table,repeat_id,min_cartid,max_cartid
    local split_str
	--print(insert_weight..","..update_single..","..update_batch..","..select_numberic..","..select_list..","..total..","..weight)

	if weight<=addcarts_range then
		--先初始化insert队列,而后从1-5号队列中pop一条，取得user_id，查询一次列表和一次总量,做insert,再push到update队列
		insert_push_dataqueue()
		local queueid=sb_rand_uniform(1,5)
		userid_repeatid_table=dataqueue.queueLockPop(queueid)
		--添加购物车
		--com.taobao.carts.service.CartMemberService@batchAddMemberCarts~lLC
		if userid_repeatid_table ~= 0 then
			split_str = lua_string_split(userid_repeatid_table,',')
			user_id=tonumber(split_str[1])
			cart_id=tonumber(split_str[2])
			table="member_cart_"..split_str[3]
			repeat_id=tonumber(split_str[4])
			min_cartid=tonumber(split_str[5])
			max_cartid=tonumber(split_str[6])
			select_1(user_id,table,repeat_id)
			select_2(user_id,table,repeat_id)
			insert(user_id,table,cart_id)
			--insert结束后,入10号队列，记录四个值：user_id,table,cart_id,repeat_id,  即记录了每个user_id及user_id对应的cart_id和cart_id最大值,和当时插入的表
			if dataqueue.queueFull(10) == 0 then
				dataqueue.queueLockPush(10,userid_repeatid_table);
			--print(i.."--insert--"..sysbench.tid)
			end
        end


    else
        userid_repeatid_table = dataqueue.queueLockPop(10)
	--print("1 =============="..type(userid_repeatid_table))
        if userid_repeatid_table == 0 then
			userid_repeatid_table=dataqueue.queueLockFilePop(0,filename,200)
	end
		if  userid_repeatid_table ~= 0  then
			split_str = lua_string_split(userid_repeatid_table,',')
			user_id=tonumber(split_str[1])
			cart_id=tonumber(split_str[2])
			table="member_cart_"..split_str[3]
			repeat_id=tonumber(split_str[4])
			min_cartid=tonumber(split_str[5])
			max_cartid=tonumber(split_str[6])
			if weight<=queryCartsList_range  then
				--查看购物车
				--com.taobao.carts.service.CartMemberService@queryMemberCartItems~lC
				select_2(user_id,table,repeat_id)

			elseif  weight<=queryItemByCarts_range then
				--通过购物车查看商品
				--com.taobao.carts.service.CartMemberService@queryMemberCartItems~l[C
				select_3(user_id,table,repeat_id)

			elseif  weight<=updateItemQuantity_range then
				--更新购物车商品数量
				--com.taobao.carts.service.CartMemberService@updateMemberCartItemQuantity~lliC
				update_1(user_id,table,cart_id)

			elseif weight<=deleteByOrder_range then
				--从购物车下单删除购物车商品
				--com.taobao.cart.service.CartSubBizServiceApi@deleteMemberCartItems~[lC
				update_2(user_id,table,repeat_id,min_cartid,max_cartid)

			elseif weight<=deleteByUser_range then
				--用户删除购物车商品
				--com.taobao.carts.service.CartMemberService@deleteMemberCartItems~l[C
				update_2(user_id,table,repeat_id,min_cartid,max_cartid)
				select_2(user_id,table,repeat_id)


			end
		end
	end
end