sysbench.cmdline.options={
	tableName=
	{"do ddl for target table,which is the table Name",nil},
	tableSize=
	{"table size",1},
	valueSize=
	{"how many current table will be created",1},
	columnInfo=
	{"format=(col1,col2,col3...)",nil},
	columnType=
	{"format=type1 type2 type3...",nil},
	autoStart=
	{"autoIncrement start number...",-1},
	interval=
	{"interval for each event...",0},
	rowSize=
	{"max row size for each table...",-1}
}

function generate_one_row(source)

	local sql_content="("
   	for type in string.gmatch(source, "[^%s]+") do
 	     if type ~= nil then
 			lowercase=string.lower(type)
 		 	if (string.find(lowercase,"int") ~=nil and string.find(lowercase,"int") >=0) then
 		    	int_value=sysbench.rand.uniform(1,10000)
				sql_content=sql_content..int_value..","
 			elseif (string.find(lowercase,"varchar") ~=nil and string.find(lowercase,"varchar") >=0) then
                --intValue=sysbench.rand.uniform(100,1000)
                --sql_content=sql_content.."'hellworld"..intValue.."',"
                intValue=sysbench.rand.uniform(1,1000000)
                sql_content=sql_content.."'Applesrestoretwofullpointsofhunger.ButWAIT!Theycanalsobecraftedwithgoldin"..intValue.."',"
 			elseif (string.find(lowercase,"double") ~=nil and string.find(lowercase,"double") >=0) or (string.find(lowercase,"float") ~=nil and string.find(lowercase,"float") >=0) then
 			    intValue=sysbench.rand.uniform(1,10000)
				doubleValue=sysbench.rand.default(1,10000)
				sql_content=sql_content..intValue.."."..doubleValue..","
			elseif (string.find(lowercase,"date") ~=nil and string.find(lowercase,"date") >=0) then
				monthRand=sysbench.rand.uniform(1,9)
				dateRand=sysbench.rand.uniform(10,28)
				--sql_content=sql_content.."'2018-0"..monthRand.."-"..dateRand.."',"
				sql_content=sql_content.."'2018-01-"..dateRand.."',"
			elseif (string.find(lowercase,"timestamp")~=nil and string.find(lowercase,"timestamp")>=0) then
				sql_content=sql_content.."now(),"
			elseif (string.find(lowercase,"time") ~=nil and string.find(lowercase,"time")>=0) then
				hourRand=sysbench.rand.uniform(10,23)
				minsecRand=sysbench.rand.uniform(10,59)
				sql_content=sql_content.."'"..hourRand..":"..minsecRand..":"..minsecRand.."',"
			elseif (string.find(lowercase,"auto_increment") ~=nil and string.find(lowercase,"auto_increment")>=0) then
				sql_content=sql_content.."autoColumn,"
			elseif (string.find(lowercase,"multivalue01") ~=nil and string.find(lowercase,"multivalue01")>=0) then
				--multiValue01: a,b,c,...,xx; 
				length=sysbench.rand.uniform(1,20)
				array = {"Lua", "Tutorial","卫熹测试","abc","hellworld","tellme!!","abdc","a","淘宝","天猫","超时空","teriiable","xx","verary good","really happe fdfd","happy day","c","d","阿里","游乐园"}
				multiValue01=""
				for i=1,length do
					pos=sysbench.rand.uniform(1,20)
					valuePos=array[pos]
					multiValue01=multiValue01..valuePos..","
				end
				mutliValue01=multiValue01.."end"
				sql_content=sql_content.."'"..multiValue01.."',"
			elseif (string.find(lowercase,"multivalue02") ~=nil and string.find(lowercase,"multivalue02")>=0)  then
				length=sysbench.rand.uniform(1,20)
				array = {"Lua:10", "Tutorial:20","卫熹测试:30","abc:40","hellworld:3","tellme!!:24","abdc:10","a:3","淘宝:20","天猫:4","超时空:1","teriiable:1","xx:10","verary good:33","really happe fdfd:101","happy day:8","c:2","d:10","阿里:10","游乐园:88"}
				multiValue02=""
				for i=1,length do
					pos=sysbench.rand.uniform(1,20)
					valuePos=array[pos]
				    multiValue02=multiValue02..valuePos..","
				end
				mutliValue02=multiValue02.."end:2"
				sql_content=sql_content.."'"..multiValue02.."',"
			elseif (string.find(lowercase,"binary") ~=nil and string.find(lowercase,"binary")>=0)  then
				array= {"0x4000","0x42","0x41","0x4142434445","0x44","0x96","0x32","0x97","0x45","0x4645","0x46454443"}
				randInt=sysbench.rand.uniform(1,#array)
				sql_content=sql_content..array[randInt]..","
			else
 			    print("not define types")
 			end
 		end
 	end
	sql_content=string.sub(sql_content, 1, string.len(sql_content)-1)
    sql_content=sql_content..")"
	return sql_content
end

function thread_init(thread_id)
   --local curTime=os.date("%Y-%m-%d %H:%M:%S");
   --print("current Time ==>"..curTime)
   drv = sysbench.sql.driver()
   con = drv:connect()
   

   values = ""
   tableAVG=false
   local source=sysbench.opt.columnType
   local onerow=generate_one_row(source)
   values=values..onerow

   counter=1
   while (counter<sysbench.opt.valueSize) do
	 onerow=generate_one_row(source)
     values=values..","..onerow
	 counter = counter + 1
   end
   
   autoColumn=sysbench.opt.autoStart
   currentTN=0   
   threadMarkPerT=0;
   if (sysbench.opt.threads % sysbench.opt.tableSize) == 0 then
	  tableAVG=true
	  currentTN=(thread_id%sysbench.opt.threads)%sysbench.opt.tableSize +1
	  threadMarkPerT=math.floor((thread_id/sysbench.opt.tableSize) + 1)
	  local table_name = sysbench.opt.tableName..currentTN
	  stmt = "insert into "..table_name.. sysbench.opt.columnInfo.." values"
	  stmt=stmt..values
  else
	  tableAVG=false
  end
end

function event(thread_id)
	local eventValues=values
	local realStmt=stmt
	if tableAVG  then
    	   if autoColumn ~= -1 then
		   if sysbench.opt.rowSize ~=-1 then
		   		if autoColumn > sysbench.opt.rowSize then
					print("manually kill threads")
					os.exit()
				end
		   end
		   for i=1 , sysbench.opt.valueSize do
			    if sysbench.opt.threads == sysbench.opt.tableSize then
				  newValue=autoColumn	
				else
			      	  newValue=threadMarkPerT..autoColumn
			    end
			    realStmt=string.gsub(realStmt,"autoColumn",newValue,1)
			    autoColumn =autoColumn + 1
		   end
		end
		
		con:query(realStmt)
	else
 	    	currentTN=sysbench.rand.uniform(1,sysbench.opt.tableSize)
		local table_name = sysbench.opt.tableName..currentTN
		stmt = "insert into "..table_name.. sysbench.opt.columnInfo.." values"
		stmt=stmt..values
		con:query(stmt)
 	end
	
	if sysbench.opt.interval >0  then
		os.execute("sleep " .. sysbench.opt.interval)
	end
end

function sysbench.hooks.report_intermediate(stat)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end



