#!/usr/bin/env sysbench
-- -------------------------------------------------------------------------- --
-- create/drop trigger
-- -------------------------------------------------------------------------- --


cursize=0

function thread_init()
    drv = sysbench.sql.driver()
    con = drv:connect()
end

function prepare()

    local drv = sysbench.sql.driver()
    local con = drv:connect()


    print("Create triger_test 1")
    con:query("CREATE TABLE if not exists  triger_test (   `id` int(11)  )")

    print("Create triger_log 1")
    con:query("CREATE TABLE if not exists  triger_log (   `id` int(11) )")



end

function event(thread_id)

    do_create(thread_id)

    do_create(thread_id)

    do_create(thread_id)

    do_drop(thread_id)

end


function cleanup()

    do_clean_up()

end

function do_clean_up()

    local drv = sysbench.sql.driver()
    local con = drv:connect()

    rs = con:query("show triggers")


    triggers = {}

    for i = 1, rs.nrows do

        row = rs:fetch_row()

        triggers[i] = row[1]
    end

    -- clean up

    for i = 1, #triggers do

        con:query("drop trigger "..triggers[i])
    end

end


function do_create(thread_id)

    drop_sqls = {

        "DROP TRIGGER if exists trigger_{thread_id}_1",

        "DROP TRIGGER if exists trigger_{thread_id}_2",

        "DROP TRIGGER if exists trigger_{thread_id}_3",

        "DROP TRIGGER if exists trigger_{thread_id}_4",

        "DROP TRIGGER if exists trigger_{thread_id}_5",

        "DROP TRIGGER if exists trigger_{thread_id}_6",

        "DROP TRIGGER if exists trigger_{thread_id}_7",

        "DROP TRIGGER if exists trigger_{thread_id}_8",

        "DROP TRIGGER if exists trigger_{thread_id}_9",

        "DROP TRIGGER if exists trigger_{thread_id}_10",

        "DROP TRIGGER if exists trigger_{thread_id}_11",

        "DROP TRIGGER if exists trigger_{thread_id}_12",

        "DROP TRIGGER if exists trigger_{thread_id}_13",

        "DROP TRIGGER if exists trigger_{thread_id}_14",

        "DROP TRIGGER if exists trigger_{thread_id}_15",

        "DROP TRIGGER if exists trigger_{thread_id}_16",

        "DROP TRIGGER if exists trigger_{thread_id}_17",

        "DROP TRIGGER if exists trigger_{thread_id}_18",

        "DROP TRIGGER if exists trigger_{thread_id}_19",

        "DROP TRIGGER if exists trigger_{thread_id}_20",

        "DROP TRIGGER if exists trigger_{thread_id}_21",

        "DROP TRIGGER if exists trigger_{thread_id}_22",

        "DROP TRIGGER if exists trigger_{thread_id}_23",

        "DROP TRIGGER if exists trigger_{thread_id}_24",

        "DROP TRIGGER if exists trigger_{thread_id}_25",

        "DROP TRIGGER if exists trigger_{thread_id}_26",

        "DROP TRIGGER if exists trigger_{thread_id}_27",

        "DROP TRIGGER if exists trigger_{thread_id}_28",

        "DROP TRIGGER if exists trigger_{thread_id}_29",

        "DROP TRIGGER if exists trigger_{thread_id}_30",

        "DROP TRIGGER if exists trigger_{thread_id}_31",

        "DROP TRIGGER if exists trigger_{thread_id}_32",

        "DROP TRIGGER if exists trigger_{thread_id}_33",

        "DROP TRIGGER if exists trigger_{thread_id}_34",

        "DROP TRIGGER if exists trigger_{thread_id}_35",

        "DROP TRIGGER if exists trigger_{thread_id}_36",

        "DROP TRIGGER if exists trigger_{thread_id}_37",

        "DROP TRIGGER if exists trigger_{thread_id}_38",

        "DROP TRIGGER if exists trigger_{thread_id}_39",

        "DROP TRIGGER if exists trigger_{thread_id}_40",

        "DROP TRIGGER if exists trigger_{thread_id}_41",

        "DROP TRIGGER if exists trigger_{thread_id}_42",

        "DROP TRIGGER if exists trigger_{thread_id}_43",

        "DROP TRIGGER if exists trigger_{thread_id}_44",

        "DROP TRIGGER if exists trigger_{thread_id}_45",

        "DROP TRIGGER if exists trigger_{thread_id}_46",

        "DROP TRIGGER if exists trigger_{thread_id}_47",

        "DROP TRIGGER if exists trigger_{thread_id}_48",

        "DROP TRIGGER if exists trigger_{thread_id}_49",

        "DROP TRIGGER if exists trigger_{thread_id}_50",

        "DROP TRIGGER if exists trigger_{thread_id}_51",

        "DROP TRIGGER if exists trigger_{thread_id}_52",

        "DROP TRIGGER if exists trigger_{thread_id}_53",

        "DROP TRIGGER if exists trigger_{thread_id}_54",

        "DROP TRIGGER if exists trigger_{thread_id}_55",

        "DROP TRIGGER if exists trigger_{thread_id}_56",

        "DROP TRIGGER if exists trigger_{thread_id}_57",

        "DROP TRIGGER if exists trigger_{thread_id}_58",

        "DROP TRIGGER if exists trigger_{thread_id}_59",

        "DROP TRIGGER if exists trigger_{thread_id}_60",

        "DROP TRIGGER if exists trigger_{thread_id}_61",

        "DROP TRIGGER if exists trigger_{thread_id}_62",

        "DROP TRIGGER if exists trigger_{thread_id}_63",

        "DROP TRIGGER if exists trigger_{thread_id}_64",

        "DROP TRIGGER if exists trigger_{thread_id}_65",

        "DROP TRIGGER if exists trigger_{thread_id}_66",

        "DROP TRIGGER if exists trigger_{thread_id}_67",

        "DROP TRIGGER if exists trigger_{thread_id}_68",

        "DROP TRIGGER if exists trigger_{thread_id}_69",

        "DROP TRIGGER if exists trigger_{thread_id}_70",

        "DROP TRIGGER if exists trigger_{thread_id}_71",

        "DROP TRIGGER if exists trigger_{thread_id}_72",

        "DROP TRIGGER if exists trigger_{thread_id}_73",

        "DROP TRIGGER if exists trigger_{thread_id}_74",

        "DROP TRIGGER if exists trigger_{thread_id}_75",

        "DROP TRIGGER if exists trigger_{thread_id}_76",

        "DROP TRIGGER if exists trigger_{thread_id}_77",

        "DROP TRIGGER if exists trigger_{thread_id}_78",

        "DROP TRIGGER if exists trigger_{thread_id}_79",

        "DROP TRIGGER if exists trigger_{thread_id}_80",

        "DROP TRIGGER if exists trigger_{thread_id}_81",

        "DROP TRIGGER if exists trigger_{thread_id}_82",

        "DROP TRIGGER if exists trigger_{thread_id}_83",

        "DROP TRIGGER if exists trigger_{thread_id}_84",

        "DROP TRIGGER if exists trigger_{thread_id}_85",

        "DROP TRIGGER if exists trigger_{thread_id}_86",

        "DROP TRIGGER if exists trigger_{thread_id}_87",

        "DROP TRIGGER if exists trigger_{thread_id}_88",

        "DROP TRIGGER if exists trigger_{thread_id}_89",

        "DROP TRIGGER if exists trigger_{thread_id}_90",

        "DROP TRIGGER if exists trigger_{thread_id}_91",

        "DROP TRIGGER if exists trigger_{thread_id}_92",

        "DROP TRIGGER if exists trigger_{thread_id}_93",

        "DROP TRIGGER if exists trigger_{thread_id}_94",

        "DROP TRIGGER if exists trigger_{thread_id}_95",

        "DROP TRIGGER if exists trigger_{thread_id}_96",

        "DROP TRIGGER if exists trigger_{thread_id}_97",

        "DROP TRIGGER if exists trigger_{thread_id}_98",

        "DROP TRIGGER if exists trigger_{thread_id}_99",

        "DROP TRIGGER if exists trigger_{thread_id}_100",

    }

    sqls = {

        "CREATE TRIGGER trigger_{thread_id}_1 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_2 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_3 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_4 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_5 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_6 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_7 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_8 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_9 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_10 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_11 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_12 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_13 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_14 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_15 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_16 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_17 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_18 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_19 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_20 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_21 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_22 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_23 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_24 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_25 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_26 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_27 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_28 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_29 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_30 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_31 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_32 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_33 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_34 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_35 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_36 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_37 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_38 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_39 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_40 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_41 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_42 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_43 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_44 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_45 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_46 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_47 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_48 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_49 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_50 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_51 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_52 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_53 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_54 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_55 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_56 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_57 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_58 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_59 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_60 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_61 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_62 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_63 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_64 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_65 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_66 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_67 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_68 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_69 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_70 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_71 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_72 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_73 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_74 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_75 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_76 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_77 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_78 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_79 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_80 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_81 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_82 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_83 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_84 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_85 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_86 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_87 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_88 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_89 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_90 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_91 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_92 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_93 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_94 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_95 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_96 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_97 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_98 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_99 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

        "CREATE TRIGGER trigger_{thread_id}_100 BEFORE INSERT ON triger_test FOR EACH ROW INSERT INTO triger_log VALUES(1)",

    }

    num = math.random(100);

    con:query(string.gsub(drop_sqls[num],"{thread_id}",tostring(thread_id)))

    con:query(string.gsub(sqls[num],"{thread_id}",tostring(thread_id)))

end


function do_drop(thread_id)

    drop_sqls = {

        "DROP TRIGGER if exists trigger_{thread_id}_1",

        "DROP TRIGGER if exists trigger_{thread_id}_2",

        "DROP TRIGGER if exists trigger_{thread_id}_3",

        "DROP TRIGGER if exists trigger_{thread_id}_4",

        "DROP TRIGGER if exists trigger_{thread_id}_5",

        "DROP TRIGGER if exists trigger_{thread_id}_6",

        "DROP TRIGGER if exists trigger_{thread_id}_7",

        "DROP TRIGGER if exists trigger_{thread_id}_8",

        "DROP TRIGGER if exists trigger_{thread_id}_9",

        "DROP TRIGGER if exists trigger_{thread_id}_10",

        "DROP TRIGGER if exists trigger_{thread_id}_11",

        "DROP TRIGGER if exists trigger_{thread_id}_12",

        "DROP TRIGGER if exists trigger_{thread_id}_13",

        "DROP TRIGGER if exists trigger_{thread_id}_14",

        "DROP TRIGGER if exists trigger_{thread_id}_15",

        "DROP TRIGGER if exists trigger_{thread_id}_16",

        "DROP TRIGGER if exists trigger_{thread_id}_17",

        "DROP TRIGGER if exists trigger_{thread_id}_18",

        "DROP TRIGGER if exists trigger_{thread_id}_19",

        "DROP TRIGGER if exists trigger_{thread_id}_20",

        "DROP TRIGGER if exists trigger_{thread_id}_21",

        "DROP TRIGGER if exists trigger_{thread_id}_22",

        "DROP TRIGGER if exists trigger_{thread_id}_23",

        "DROP TRIGGER if exists trigger_{thread_id}_24",

        "DROP TRIGGER if exists trigger_{thread_id}_25",

        "DROP TRIGGER if exists trigger_{thread_id}_26",

        "DROP TRIGGER if exists trigger_{thread_id}_27",

        "DROP TRIGGER if exists trigger_{thread_id}_28",

        "DROP TRIGGER if exists trigger_{thread_id}_29",

        "DROP TRIGGER if exists trigger_{thread_id}_30",

        "DROP TRIGGER if exists trigger_{thread_id}_31",

        "DROP TRIGGER if exists trigger_{thread_id}_32",

        "DROP TRIGGER if exists trigger_{thread_id}_33",

        "DROP TRIGGER if exists trigger_{thread_id}_34",

        "DROP TRIGGER if exists trigger_{thread_id}_35",

        "DROP TRIGGER if exists trigger_{thread_id}_36",

        "DROP TRIGGER if exists trigger_{thread_id}_37",

        "DROP TRIGGER if exists trigger_{thread_id}_38",

        "DROP TRIGGER if exists trigger_{thread_id}_39",

        "DROP TRIGGER if exists trigger_{thread_id}_40",

        "DROP TRIGGER if exists trigger_{thread_id}_41",

        "DROP TRIGGER if exists trigger_{thread_id}_42",

        "DROP TRIGGER if exists trigger_{thread_id}_43",

        "DROP TRIGGER if exists trigger_{thread_id}_44",

        "DROP TRIGGER if exists trigger_{thread_id}_45",

        "DROP TRIGGER if exists trigger_{thread_id}_46",

        "DROP TRIGGER if exists trigger_{thread_id}_47",

        "DROP TRIGGER if exists trigger_{thread_id}_48",

        "DROP TRIGGER if exists trigger_{thread_id}_49",

        "DROP TRIGGER if exists trigger_{thread_id}_50",

        "DROP TRIGGER if exists trigger_{thread_id}_51",

        "DROP TRIGGER if exists trigger_{thread_id}_52",

        "DROP TRIGGER if exists trigger_{thread_id}_53",

        "DROP TRIGGER if exists trigger_{thread_id}_54",

        "DROP TRIGGER if exists trigger_{thread_id}_55",

        "DROP TRIGGER if exists trigger_{thread_id}_56",

        "DROP TRIGGER if exists trigger_{thread_id}_57",

        "DROP TRIGGER if exists trigger_{thread_id}_58",

        "DROP TRIGGER if exists trigger_{thread_id}_59",

        "DROP TRIGGER if exists trigger_{thread_id}_60",

        "DROP TRIGGER if exists trigger_{thread_id}_61",

        "DROP TRIGGER if exists trigger_{thread_id}_62",

        "DROP TRIGGER if exists trigger_{thread_id}_63",

        "DROP TRIGGER if exists trigger_{thread_id}_64",

        "DROP TRIGGER if exists trigger_{thread_id}_65",

        "DROP TRIGGER if exists trigger_{thread_id}_66",

        "DROP TRIGGER if exists trigger_{thread_id}_67",

        "DROP TRIGGER if exists trigger_{thread_id}_68",

        "DROP TRIGGER if exists trigger_{thread_id}_69",

        "DROP TRIGGER if exists trigger_{thread_id}_70",

        "DROP TRIGGER if exists trigger_{thread_id}_71",

        "DROP TRIGGER if exists trigger_{thread_id}_72",

        "DROP TRIGGER if exists trigger_{thread_id}_73",

        "DROP TRIGGER if exists trigger_{thread_id}_74",

        "DROP TRIGGER if exists trigger_{thread_id}_75",

        "DROP TRIGGER if exists trigger_{thread_id}_76",

        "DROP TRIGGER if exists trigger_{thread_id}_77",

        "DROP TRIGGER if exists trigger_{thread_id}_78",

        "DROP TRIGGER if exists trigger_{thread_id}_79",

        "DROP TRIGGER if exists trigger_{thread_id}_80",

        "DROP TRIGGER if exists trigger_{thread_id}_81",

        "DROP TRIGGER if exists trigger_{thread_id}_82",

        "DROP TRIGGER if exists trigger_{thread_id}_83",

        "DROP TRIGGER if exists trigger_{thread_id}_84",

        "DROP TRIGGER if exists trigger_{thread_id}_85",

        "DROP TRIGGER if exists trigger_{thread_id}_86",

        "DROP TRIGGER if exists trigger_{thread_id}_87",

        "DROP TRIGGER if exists trigger_{thread_id}_88",

        "DROP TRIGGER if exists trigger_{thread_id}_89",

        "DROP TRIGGER if exists trigger_{thread_id}_90",

        "DROP TRIGGER if exists trigger_{thread_id}_91",

        "DROP TRIGGER if exists trigger_{thread_id}_92",

        "DROP TRIGGER if exists trigger_{thread_id}_93",

        "DROP TRIGGER if exists trigger_{thread_id}_94",

        "DROP TRIGGER if exists trigger_{thread_id}_95",

        "DROP TRIGGER if exists trigger_{thread_id}_96",

        "DROP TRIGGER if exists trigger_{thread_id}_97",

        "DROP TRIGGER if exists trigger_{thread_id}_98",

        "DROP TRIGGER if exists trigger_{thread_id}_99",

        "DROP TRIGGER if exists trigger_{thread_id}_100",

    }

    con:query(string.gsub(drop_sqls[num],"{thread_id}",tostring(thread_id)))

end