--sqlfile只接受1个参数变化

sysbench.cmdline.options={
	sqlfile=
	{"the absoulute path for the sqlfile",nil},
	interval=
	{"s,the interval time when to execute the file",0}
}

function thread_init(thread_id)
--   local curTime=os.date("%Y-%m-%d %H:%M:%S");
--   print("current Time ==>"..curTime)
   drv = sysbench.sql.driver()
   con = drv:connect()
   if sysbench.opt.sqlfile == nil then
   		print("[ERROR] sqlfile is a required parameter")	
	    os.exit()	
   end
  
   sqls={}
   --read sql file, and put it in a array，sql clause is split by ;
   for line in io.lines(sysbench.opt.sqlfile) do
	   table.insert(sqls,line)
   end
end

function event()
	for pos = 1,#sqls do
		local sourceSQL=sqls[pos]
		parameters_pos=string.match(sourceSQL,"params##.+")
		if parameters_pos ~= nil then
			input_parameters=string.sub(parameters_pos,9,string.len(parameters_pos)-2)
			sourceSQL=string.gsub(sourceSQL,parameters_pos,"")
			local parameterPos=1
			for onePara in string.gmatch(input_parameters, "[^%s]+") do
				local replace=string.format("@@para%d",parameterPos)
				onePara=string.gsub(onePara,'#','')
				--onePara =string.sub(onePara,2,string.len(onePara)-1)
				if string.find(onePara,",") ~=nil then
					onePara=string.gsub(onePara,","," ")
					for word in string.gmatch(inputs,"[^%s]+") do
						if word ~= nil then
							executeSourceSQL=string.gsub(sourceSQL,replace,word)
							print('execute SQL ------->'..executeSouceSQL)
							con:query(executeSourceSQL)
						end
					end
				elseif string.find(onePara,"~") then
					local startPos=string.find(onePara,"~")
				   	local startV=string.sub(onePara,1,startPos-1)
				    local endV=string.sub(onePara,startPos+1,string.len(onePara))
				    for i=tonumber(startV),tonumber(endV) do
						executeSourceSQL=string.gsub(sourceSQL,replace,i)
						print("execute SQL----->"..executeSourceSQL)
						con:query(executeSourceSQL)
					end             
				else
				    print("ERROR sqlfile including not formated parameters"..inputs)
				    os.exit()
				end
			end
		else
			con:query(sourceSQL)
		end
	end

	if sysbench.opt.interval >0 then
		os.execute("sleep " .. sysbench.opt.interval)
	end
end

