
-- Command line options
sysbench.cmdline.options = {
    skip_trx =
        {"Don't start explicit transactions and execute all queries " ..
             "in the AUTOCOMMIT mode", false}
}

function thread_init(thread_id)

   drv = sysbench.sql.driver()
   con = drv:connect()

   if drv:name() == "mysql" then 
       if not sysbench.opt.skip_trx then
           con:query("SET autocommit=0")
       end
   end
   myid = thread_id
end

function event()
  con:query("select 1")
end

function sysbench.hooks.before_restart_event(err)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
-- --   print("my stat: ", val)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end


