sysbench.cmdline.options={
	sqlfile=
	{"the absoulute path for the sqlfile",nil},
	interval=
	{"s,the interval time when to execute the file",0}
}

function thread_init(thread_id)
   drv = sysbench.sql.driver()
   con = drv:connect()
   if sysbench.opt.sqlfile == nil then
   		print("[ERROR] sqlfile is a required parameter")	
	   os.exit()	
   end
  
   sqls={}
   --read sql file, and put it in a array，sql clause is split by ;
   for line in io.lines(sysbench.opt.sqlfile) do
	   table.insert(sqls,line)
   end
end

--input: #a,b,c,d# || #a~b#
function  get_specific_value(inputs)
	inputs=string.sub(inputs,2,string.len(inputs)-1)
	if string.find(inputs,",") ~=nil then
		inputs=string.gsub(inputs,","," ")
		results={}
		for word in string.gmatch(inputs,"[^%s]+") do
			if word ~= nil then
				table.insert(results,word)
			end
		end
    	randomPos=sysbench.rand.uniform(1,#results)
		return results[randomPos]
	elseif string.find(inputs,"~") then
		local startPos=string.find(inputs,"~")
		local startV=string.sub(inputs,1,startPos-1)
		local endV=string.sub(inputs,startPos+1,string.len(inputs))
		local result=sysbench.rand.uniform(tonumber(startV),tonumber(endV))
		return result
	else
		print("ERROR sqlfile including not formated parameters"..inputs)
		os.exit()
	end
end

function event()
	--random obtain execute sql
	pos=sysbench.rand.uniform(1, #sqls)
	local sourceSQL=sqls[pos]

	--check if params###a,b,c,d,f# #1,2,3,4,5### specific value ||  params###12~35# ## range 
	parameters_pos=string.match(sourceSQL,"params##.+")
	if parameters_pos ~= nil then
		input_parameters=string.sub(parameters_pos,9,string.len(parameters_pos)-2)
		sourceSQL=string.gsub(sourceSQL,parameters_pos,"")
		local parameterPos=1
		for onePara in string.gmatch(input_parameters, "[^%s]+") do
			local replace=string.format("@@para%d",parameterPos)
			sourceSQL=string.gsub(sourceSQL,replace,get_specific_value(onePara))
			parameterPos=parameterPos+1
		end
		--print("sql=> "..sourceSQL)
		con:query(sourceSQL)
	else
		con:query(sourceSQL)

	end
	--os.execute("sleep " .. interval)
end

