#!/usr/bin/env sysbench

function prepare()
	drv = sysbench.sql.driver()
	con = drv:connect()
	con:query("drop table if exists normal_prepare")
	con:query("CREATE TABLE normal_prepare ( id int(11) DEFAULT NULL, name varchar(11), hobby varchar(11) ) ENGINE=InnoDB")
	con:query("insert into normal_prepare values(1, 'daniel', 'computer')")
	con:disconnect()
end

function cleanup()
end

function thread_init()
   drv = sysbench.sql.driver()
end

function thread_done()
end

function event()
   con = drv:connect()

   --con:query("select 1")
   stmt = con:prepare("SET NAMES  'utf8mb4' collate 'utf8mb4_unicode_ci'")
   stmt:execute()
   stmt:close()
   stmt = con:prepare("set time_zone='+08:00'")
   stmt:execute()
   stmt:close()
   
   stmt = con:prepare("set session sql_mode='NO_ENGINE_SUBSTITUTION'")
   stmt:execute()
   stmt:close()

   stmt = con:prepare("select * from testdb.normal_prepare where id = ?;")
   param = stmt:bind_create(sysbench.sql.type.INT)
   param:set(1)
   stmt:bind_param(param)
   stmt:execute()
   stmt:close()

   con:disconnect()
  
   --con = drv:connect()
   --con:query(" SET NAMES  'utf8mb4' collate 'utf8mb4_unicode_ci';SET NAMES  'utf8mb4' collate 'utf8mb4_unicode_ci'")
   --con:query(" select 1;set time_zone='+08:00'")
   --con:query(" select 1;set session sql_mode='NO_ENGINE_SUBSTITUTION'")
   --con:query(" select 1;select * from testdb.normal_prepare where id =1;")
   --con:disconnect()
end
