-- /root/sysbench/bin/sysbench --mysql-ignore-errors=2006,1213,3019,1412,1205,13259,3790,8008 --mysql_password=Passw0rd --report_interval=1 --mysql_db=tpch10g --mysql_host=100.81.231.222 --db_driver=mysql --mysql_user=myadmin --threads=10 --mysql_port=5200 --time=0 --events=0  --db-ps-mode=disable tpch_long_query.lua run
require("timed_event")

if sysbench.cmdline.command == nil then
    error("Command is required. Supported commands: run")
end

sysbench.cmdline.options={
    report_csv =
       {"Report output in csv (yes, no)", "no"},
    target_tps =
       {"Desiried transaction throughput (TPS)",-1}
}

function thread_init(thread_id)
   drv = sysbench.sql.driver()
   con = drv:connect()
end

function event()

	local max_op =  1
    local op_type = sysbench.rand.uniform(1,10)

	if op_type ==1 then
		stmt = ([[select n_nationkey,n_name
		from %s.nation where n_nationkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,24))
    elseif op_type == 2 then
        stmt  = ([[select now()]])
    elseif op_type == 3 then
        stmt = ([[select 1]])
    elseif op_type == 4 then
        stmt = ([[select n_nationkey,n_name from %s.nation order by n_nationkey limit 1]]):format(sysbench.opt.mysql_db)
    elseif op_type ==5 then
        stmt =([[select r_regionkey,r_name from %s.region where r_regionkey = %s]]):format(
            sysbench.opt.mysql_db,
            sysbench.rand.uniform(0,4))
    elseif op_type == 6 then
        stmt = ([[select * from %s.region order by r_regionkey]]):format(sysbench.opt.mysql_db)
    elseif op_type == 7 then
        stmt = ([[select min(r_regionkey) from %s.region]]):format(sysbench.opt.mysql_db)
    elseif op_type ==8 then
        stmt = ([[select min(n_nationkey) from %s.nation]]):format(sysbench.opt.mysql_db)
    elseif op_type ==9 then
        stmt = ([[select min(s_suppkey) from %s.supplier]]):format(sysbench.opt.mysql_db)
    else
        stmt=  ([[select s_suppkey,s_nationkey from %s.supplier where s_suppkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,1000))
    end
    -- print(stmt)
    con:query(stmt)

end

function sysbench.hooks.report_intermediate(stat)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end



